FormItMaker.grid.Formelements = function(config) {
    config = config || {};

    Ext.applyIf(config,{
        id: 'formitmaker-grid-formelements'
        ,url: FormItMaker.config.connectorUrl
        ,baseParams: { action: 'mgr/formelements/list', form: MODx.request.id }
        ,save_action: 'mgr/formelements/updatefromgrid'
        ,preventSaveRefresh: 0
        ,fields: ['id','title','formindex','fieldtype','fieldvalues','valblank','valrequired','valemail','valminlength','valmaxlength','valminvalue','valmaxvalue','valcontains','valstriptags','valisnumber','valadvanced','customchunk']
        ,paging: false
        ,autosave: true
        ,anchor: '97%'
        ,autoExpandColumn: 'title'
        ,columns: [{
            header: _('id')
            ,dataIndex: 'id'
            ,sortable: true
            ,width: 10
        },{
            header: _('formitmaker.formelements.title')
            ,dataIndex: 'title'
            ,sortable: true
            ,editor: {xtype: 'textfield'}
        },{
            header: _('formitmaker.formelements.fieldtype')
            ,dataIndex: 'fieldtype'
            ,sortable: true
            ,editor: {
                xtype: 'modx-combo'
                ,url: FormItMaker.config.connectorUrl
                ,fields: ['fieldtype']
                ,displayField: 'fieldtype'
                ,valueField: 'fieldtype'
                ,baseParams: {action: 'mgr/formelements/fieldtypes'}
                ,name: 'fieldtype'
                ,allowBlank: false
            }
        },{
            header: _('formitmaker.formelements.formindex')
            ,dataIndex: 'formindex'
            ,sortable: true
            ,editor: {xtype: 'numberfield'}
        }]
        ,tbar: [{
            text: _('formitmaker.formelements.new')
            ,handler: this.createFormelement
        },{
            text: _('formitmaker.formelements.backtoforms')
            ,handler: function() { document.location.href="index.php?a="+MODx.request.a;}
        }]
    });
    FormItMaker.grid.Formelements.superclass.constructor.call(this,config)
};
Ext.extend(FormItMaker.grid.Formelements,MODx.grid.Grid,{
    getMenu: function() {
        var m = [{
                text: _('formitmaker.formelements.remove')
                ,handler: this.removeFormelement
            },{
                text: _('formitmaker.formelements.update')
                ,handler: this.updateFormelement
            }
        ];
        this.addContextMenuItem(m);
        return true;
    }
    ,removeFormelement: function() {
        MODx.msg.confirm({
            title: _('formitmaker.formelements.remove')
            ,text: _('formitmaker.formelements.remove.confirm')
            ,url: this.config.url
            ,params: {
                action: 'mgr/formelements/remove'
                ,formelementId: this.menu.record.id
            }
            ,listeners: {
                'success': {fn:this.refresh,scope:this}
            }
        });
    }
    ,createFormelement: function(btn,e) {
        if (!this.FormelementWindow) {
            this.FormelementWindow = MODx.load({
                xtype: 'formitmaker-window-formelement'
            });
        }
        this.FormelementWindow.show(e.target);
        this.FormelementWindow.setTitle(_('formitmaker.formelements.create'));
        Ext.getCmp('formitmaker-formelement-form').form.reset();
    }
    ,updateFormelement: function(btn,e) {
        if (!this.FormelementWindow) {
            this.FormelementWindow = MODx.load({
                xtype: 'formitmaker-window-formelement'
            });
        }
        this.FormelementWindow.show(e.target);
        this.FormelementWindow.setTitle(_('formitmaker.formelements.update'));
        Ext.getCmp('formitmaker-formelement-form').form.reset();
        Ext.getCmp('formitmaker-formelement-form').form.setValues(this.menu.record);
    }
});
Ext.reg('formitmaker-grid-formelements',FormItMaker.grid.Formelements);

FormItMaker.window.Formelement = function(config) {
    config = config || {};
    Ext.applyIf(config,{
        id: 'formitmaker-window-formelement'
        ,title: _('formitmaker.formelements.new')
        ,keys: []
        ,width: 600
        ,buttons: [{
            process: 'submit',
            text: _('save'),
            handler: function() {
                frm = Ext.getCmp('formitmaker-formelement-form').form;

                if (frm.isValid()) {
                    frm.submit({
                        waitMsg: _('saving'),
                        success: function(form,action) {
                            console.log(this);
                            Ext.getCmp('formitmaker-window-formelement').hide();
                            Ext.getCmp('formitmaker-grid-formelements').refresh();
                        },
                        failure: function(form,action) {
                            Ext.MessageBox.alert(_('error'),_('formitmaker.error.undefined'));
                        }
                    })
                }
                else {
                    Ext.MessageBox.alert(_('error'),_('formitmaker.error.missingrequired'));
                }
            }
        }]
        ,items: [{
                xtype: 'form',
                url: FormItMaker.config.connectorUrl,
                baseParams: {
                    action: 'mgr/formelements/update'
                },
                forceLayout: true,
                id: 'formitmaker-formelement-form',
                items: [
                    {
                        xtype: 'modx-tabs',
                        defaults: {
                            layout: 'form',
                            labelWidth: 150,
                            autoHeight: true,
                            hideMode: 'offsets',
                            bodyStyle: 'padding: 15px',
                            border: false,
                            xtype: 'modx-panel'
                        },
                        items: [
                            {
                                title: _('formitmaker.formelements.general'),
                                items: [
                                    {
                                        xtype: 'hidden'
                                        ,name: 'id'
                                    },
                                    {
                                        xtype: 'hidden'
                                        ,name: 'form'
                                        ,value: MODx.request.id
                                    },
                                    {
                                        xtype: 'textfield'
                                        ,fieldLabel: _('formitmaker.formelements.title')
                                        ,name: 'title'
                                        ,width: 300
                                        ,allowBlank: false
                                    },
                                    {
                                        xtype: 'modx-combo'
                                        ,url: FormItMaker.config.connectorUrl
                                        ,fields: ['fieldtype']
                                        ,displayField: 'fieldtype'
                                        ,valueField: 'fieldtype'
                                        ,baseParams: {action: 'mgr/formelements/fieldtypes'}
                                        ,fieldLabel: _('formitmaker.formelements.fieldtype')
                                        ,name: 'fieldtype'
                                        ,width: 300
                                        ,allowBlank: false
                                    },
                                    {
                                        xtype: 'textarea'
                                        ,fieldLabel: _('formitmaker.formelements.fieldvalues')
                                        ,name: 'fieldvalues'
                                        ,width: 300
                                        ,allowBlank: true
                                    },
                                    {
                                        xtype: 'numberfield'
                                        ,fieldLabel: _('formitmaker.formelements.formindex')
                                        ,name: 'formindex'
                                        ,width: 300
                                        ,allowBlank: true
                                    }
                            ]}
                            ,{
                                title: _('formitmaker.formelements.val.validation'),
                                items: [
                                    {
                                        xtype: 'checkbox'
                                        ,fieldLabel: _('formitmaker.formelements.val.blank')
                                        ,name: 'valblank'
                                        ,inputValue: 1
                                    },
                                    {
                                        xtype: 'checkbox'
                                        ,fieldLabel: _('formitmaker.formelements.val.required')
                                        ,name: 'valrequired'
                                        ,inputValue: 1
                                    },
                                    {
                                        xtype: 'checkbox'
                                        ,fieldLabel: _('formitmaker.formelements.val.email')
                                        ,name: 'valemail'
                                        ,inputValue: 1
                                    },
                                    {
                                        xtype: 'numberfield'
                                        ,fieldLabel: _('formitmaker.formelements.val.minlength')
                                        ,name: 'valminlength'
                                        ,width: 300
                                        ,allowBlank: true
                                    },
                                    {
                                        xtype: 'numberfield'
                                        ,fieldLabel: _('formitmaker.formelements.val.maxlength')
                                        ,name: 'valmaxlength'
                                        ,width: 300
                                        ,allowBlank: true
                                    },
                                    {
                                        xtype: 'numberfield'
                                        ,fieldLabel: _('formitmaker.formelements.val.minvalue')
                                        ,name: 'valminvalue'
                                        ,width: 300
                                        ,allowBlank: true
                                    },
                                    {
                                        xtype: 'numberfield'
                                        ,fieldLabel: _('formitmaker.formelements.val.maxvalue')
                                        ,name: 'valmaxvalue'
                                        ,width: 300
                                        ,allowBlank: true
                                    },
                                    {
                                        xtype: 'textfield'
                                        ,fieldLabel: _('formitmaker.formelements.val.contains')
                                        ,name: 'valcontains'
                                        ,width: 300
                                        ,allowBlank: true
                                    },
                                    {
                                        xtype: 'checkbox'
                                        ,fieldLabel: _('formitmaker.formelements.val.striptags')
                                        ,name: 'valstriptags'
                                        ,inputValue: 1
                                    },
                                    {
                                        xtype: 'checkbox'
                                        ,fieldLabel: _('formitmaker.formelements.val.isnumber')
                                        ,name: 'valisnumber'
                                        ,inputValue: 1
                                    },
                                    {
                                        xtype: 'textfield'
                                        ,fieldLabel: _('formitmaker.formelements.val.advanced')
                                        ,name: 'valadvanced'
                                        ,width: 300
                                        ,allowBlank: true
                                    }
                                ]
                            },
                            {
                                title: _('formitmaker.formelements.advanced'),
                                items: [{
                                    xtype: 'textfield'
                                    ,fieldLabel: _('formitmaker.formelements.customchunk')
                                    ,name: 'customchunk'
                                    ,allowBlank: true
                                }]
                            }
                        ]
                    }
                ]
            }
        ]
    });
    FormItMaker.window.Formelement.superclass.constructor.call(this,config);
};
Ext.extend(FormItMaker.window.Formelement,MODx.Window);
Ext.reg('formitmaker-window-formelement',FormItMaker.window.Formelement);