FormItMaker.grid.Forms = function(config) {
    config = config || {};

    Ext.applyIf(config,{
        id: 'formitmaker-grid-forms'
        ,url: FormItMaker.config.connectorUrl
        ,baseParams: { action: 'mgr/forms/list' }
        ,fields: ['id','title','emailto','redirectto']
        ,paging: true
        ,autosave: true
        ,remoteSort: true
        ,anchor: '97%'
        ,autoExpandColumn: 'title'
        ,columns: [{
            header: _('id')
            ,dataIndex: 'id'
            ,sortable: true
            ,width: 10
        },{
            header: _('formitmaker.forms.title')
            ,dataIndex: 'title'
            ,sortable: true
        },{
            header: _('formitmaker.forms.emailto')
            ,dataIndex: 'emailto'
            ,sortable: true
        },{
            header: _('formitmaker.forms.redirectto')
            ,dataIndex: 'redirectto'
            ,sortable: true
        }]
        ,tbar: [{
            text: _('formitmaker.forms.new')
            ,handler: this.createForm
        },'-',{
            xtype: 'textfield'
            ,id: 'forms-search-filter'
            ,emptyText: _('formitmaker.search...')
            ,listeners: {
                'change': {fn:this.search,scope:this}
                ,'render': {fn: function(cmp) {
                    new Ext.KeyMap(cmp.getEl(), {
                        key: Ext.EventObject.ENTER
                        ,fn: function() {
                            this.fireEvent('change',this);
                            this.blur();
                            return true;
                        }
                        ,scope: cmp
                    });
                },scope:this}
            }
        }]
    });
    FormItMaker.grid.Forms.superclass.constructor.call(this,config)
};
Ext.extend(FormItMaker.grid.Forms,MODx.grid.Grid,{
    search: function(tf,nv,ov) {
        var s = this.getStore();
        s.baseParams.query = tf.getValue();
        this.getBottomToolbar().changePage(1);
        this.refresh();
    }
    ,getMenu: function() {
        var m = [{
                text: _('formitmaker.forms.remove')
                ,handler: this.removeForm
            },
            {
                text: _('formitmaker.forms.update')
                ,handler: this.updateForm
            },
            {
                text: _('formitmaker.forms.updateformelements')
                ,handler: this.updateFormelements
            }
        ];
        this.addContextMenuItem(m);
        return true;
    }
    ,removeForm: function() {
        MODx.msg.confirm({
            title: _('formitmaker.forms.remove')
            ,text: _('formitmaker.forms.remove.confirm')
            ,url: this.config.url
            ,params: {
                action: 'mgr/forms/remove'
                ,formId: this.menu.record.id
            }
            ,listeners: {
                'success': {fn:this.refresh,scope:this}
            }
        });
    }
    ,createForm: function(btn,e) {
        if (!this.CreateFormWindow) {
            this.CreateFormWindow = MODx.load({
                xtype: 'formitmaker-window-form-create'
                ,listeners: {
                    'success': function(response){
                        var jsonData = Ext.util.JSON.decode(response.a.response.responseText);
                        document.location.href="index.php?a="+MODx.request.a+"&action=formelements&id="+jsonData.object.id;
                    }
                }
            });
        }
        this.CreateFormWindow.show(e.target);
    }
    ,updateFormelements: function(btn,e) {
        document.location.href="index.php?a="+MODx.request.a+"&action=formelements&id="+this.menu.record.id;
    }
    ,updateForm: function(btn,e) {
        if (!this.UpdateFormWindow) {
            this.UpdateFormWindow = MODx.load({
                xtype: 'formitmaker-window-form-update'
                ,record: this.menu.record
                ,listeners: {
                    'success': {fn:this.refresh,scope:this}
                }
            });
        } else {
            this.UpdateFormWindow.setValues(this.menu.record);
        }
        this.UpdateFormWindow.show(e.target);
    }
});
Ext.reg('formitmaker-grid-forms',FormItMaker.grid.Forms);

FormItMaker.window.CreateForm = function(config) {
    config = config || {};
    Ext.applyIf(config,{
        id: 'formitmaker-window-form-create'
        ,title: _('formitmaker.forms.new')
        ,url: FormItMaker.config.connectorUrl
        ,baseParams: {
            action: 'mgr/forms/create'
        }
        ,fields: [
            {
                xtype: 'textfield'
                ,fieldLabel: _('formitmaker.forms.title')
                ,name: 'title'
                ,width: 300
                ,allowBlank: false
            },
            {
                xtype: 'textfield'
                ,fieldLabel: _('formitmaker.forms.emailto')
                ,name: 'emailto'
                ,width: 300
                ,allowBlank: false
            },
            {
                xtype: 'modx-combo'
                ,fieldLabel: _('formitmaker.forms.redirectto')
                ,name: 'redirectto'
                ,hiddenName: 'redirectto'
                ,anchor: '97%'
                ,displayField: 'pagetitle'
                ,valueField: 'id'
                ,fields: ['id','pagetitle']
                ,pageSize: 20
                ,url: MODx.config.connectors_url+'resource/index.php'
            }
        ]
    });
    FormItMaker.window.CreateForm.superclass.constructor.call(this,config);
};
Ext.extend(FormItMaker.window.CreateForm,MODx.Window);
Ext.reg('formitmaker-window-form-create',FormItMaker.window.CreateForm);

FormItMaker.window.UpdateForm = function(config) {
    config = config || {};
    Ext.applyIf(config,{
        id: 'formitmaker-window-form-update'
        ,title: _('formitmaker.forms.update')
        ,url: FormItMaker.config.connectorUrl
        ,baseParams: {
            action: 'mgr/forms/update'
        }
        ,fields: [
            {
                xtype: 'hidden'
                ,name: 'id'
            },{
                xtype: 'textfield'
                ,fieldLabel: _('formitmaker.forms.title')
                ,name: 'title'
                ,width: 300
                ,allowBlank: false
            },
            {
                xtype: 'textfield'
                ,fieldLabel: _('formitmaker.forms.emailto')
                ,name: 'emailto'
                ,width: 300
                ,allowBlank: false
            },
            {
                xtype: 'modx-combo'
                ,fieldLabel: _('formitmaker.forms.redirectto')
                ,name: 'redirectto'
                ,hiddenName: 'redirectto'
                ,anchor: '97%'
                ,displayField: 'pagetitle'
                ,valueField: 'id'
                ,fields: ['id','pagetitle']
                ,pageSize: 20
                ,url: MODx.config.connectors_url+'resource/index.php'
            }
        ]
    });
    FormItMaker.window.UpdateForm.superclass.constructor.call(this,config);
};
Ext.extend(FormItMaker.window.UpdateForm,MODx.Window);
Ext.reg('formitmaker-window-form-update',FormItMaker.window.UpdateForm);
Ext.reg('formitmaker-window-form-update',FormItMaker.window.UpdateForm);