<?php
/**
 * Get a list of forms
 *
 *
 * @package formitmaker
 * @subpackage processors.subscribers.list
 */

/* setup default properties */
$isLimit    = !empty($_REQUEST['limit']);
$start      = $modx->getOption('start',$_REQUEST,0);
$limit      = $modx->getOption('limit',$_REQUEST,9999999);
$sort       = $modx->getOption('sort',$_REQUEST,'fimForm.id');
$dir        = $modx->getOption('dir',$_REQUEST,'ASC');
$query      = $modx->getOption('query',$_REQUEST,'');

/* query for forms */
$c = $modx->newQuery('fimForm');

if(!empty($query)) {
    $c->where(array('fimForm.title:LIKE' => '%'.$query.'%'));
}

$count = $modx->getCount('fimForm',$c);

$c->sortby($sort,$dir);
if ($isLimit) $c->limit($limit,$start);
$forms = $modx->getCollection('fimForm',$c);

/* iterate through forms */
$list = array();
foreach ($forms as $form) {
        $list[] = $form->toArray();
}
return $this->outputArray($list,$count);